#include "StdAfx.h"
#include "ThreadPoolWrappers.h"

#pragma warning(suppress: 26440)
VOID NTAPI TimerCallback(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_ PTP_TIMER /*Timer*/)
{
  ATLTRACE(_T("In TimerCallback\n"));
}

#pragma warning(suppress: 26440)
VOID NTAPI WaitCallback(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_ PTP_WAIT /*Wait*/, _In_ TP_WAIT_RESULT /*WaitResult*/)
{
  ATLTRACE(_T("In WaitCallback\n"));
}

#pragma warning(suppress: 26440)
VOID NTAPI WorkCallback(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_ PTP_WORK /*Work*/)
{
  ATLTRACE(_T("In WorkCallback\n"));
}

#pragma warning(suppress: 26440)
void WINAPI IoCallback(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_opt_ PVOID /*Overlapped*/,
                       _In_ ULONG IoResult, _In_ ULONG_PTR NumberOfBytesTransferred, _Inout_ PTP_IO /*Io*/)
{
#pragma warning(suppress: 26472)
  ATLTRACE(_T("In IoCallback, IoResult:%u, BytesTransferred:%d\n"), IoResult, static_cast<int>(NumberOfBytesTransferred));
}

#pragma warning(suppress: 26440)
VOID NTAPI SimpleCallback(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/)
{
  ATLTRACE(_T("In SimpleCallback\n"));
}

#pragma warning(suppress: 26440)
VOID NTAPI DoWork1(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_ PTP_WORK /*Work*/)
{
  ATLTRACE(_T("In DoWork1\n"));
}

#pragma warning(suppress: 26440)
VOID NTAPI DoTimer1(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_ PTP_TIMER /*Timer*/)
{
  ATLTRACE(_T("In DoTimer1\n"));
}

#pragma warning(suppress: 26440)
VOID NTAPI DoTimer2(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_ PTP_TIMER /*Timer*/)
{
  ATLTRACE(_T("In DoTimer2\n"));
}

#pragma warning(suppress: 26440)
VOID NTAPI DoWait1(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_ PTP_WAIT /*Wait*/, _In_ TP_WAIT_RESULT WaitResult)
{
  UNREFERENCED_PARAMETER(WaitResult);
  ATLTRACE(_T("In DoWait1, WaitResult:%08x\n"), WaitResult);
}

#pragma warning(suppress: 26440)
VOID NTAPI DoWait2(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_ PTP_WAIT /*Wait*/, _In_ TP_WAIT_RESULT WaitResult)
{
  UNREFERENCED_PARAMETER(WaitResult);
  ATLTRACE(_T("In DoWait2, WaitResult:%08x\n"), WaitResult);
}

#pragma warning(suppress: 26440)
VOID NTAPI DoTimer3(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_ PTP_TIMER /*Timer*/)
{
  ATLTRACE(_T("In DoTimer3\n"));
}

#pragma warning(suppress: 26440)
VOID NTAPI DoTimer4(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_ PTP_TIMER /*Timer*/)
{
  ATLTRACE(_T("In DoTimer4\n"));
}

#pragma warning(suppress: 26440)
void WINAPI DoIo1(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_opt_ PVOID /*Overlapped*/,
                  _In_ ULONG IoResult, _In_ ULONG_PTR NumberOfBytesTransferred, _Inout_ PTP_IO /*Io*/)
{
#pragma warning(suppress: 26472)
  ATLTRACE(_T("In DoIo1, IoResult:%u, BytesTransferred:%d\n"), IoResult, static_cast<int>(NumberOfBytesTransferred));
}

VOID NTAPI CleanupCallback(_Inout_opt_ PVOID ObjectContext, _Inout_opt_ PVOID CleanupContext) noexcept
{
    UNREFERENCED_PARAMETER(ObjectContext);
    UNREFERENCED_PARAMETER(CleanupContext);
}

#pragma warning(suppress: 26440)
VOID NTAPI DoWork2(_Inout_ PTP_CALLBACK_INSTANCE /*Instance*/, _Inout_opt_ PVOID /*Context*/, _Inout_ PTP_WORK /*Work*/)
{
    //Pretend to do something for up to one time slice
    ATLTRACE(_T("In DoWork2\n"));
    const ULONGLONG nStartTick = GetTickCount64();
    while (GetTickCount64() == nStartTick)
    {
    }
}


int _tmain()
{
  //Test out the CPool class
  ThreadPoolWrappers::CPool pool1;
  bool bSuccess1 = pool1.Create(); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess1);
  pool1.SetThreadMaximum(10);
  pool1.SetThreadMinimum(1);
  TP_POOL_STACK_INFORMATION tpsi;
  BOOL bSuccess2 = pool1.QueryStackInformation(&tpsi); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSERT(bSuccess2);
  bSuccess2 = pool1.SetStackInformation(&tpsi); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSERT(bSuccess2);
#pragma warning(suppress: 26462)
  const auto g1 = pool1.get();
  UNREFERENCED_PARAMETER(g1);
  ThreadPoolWrappers::CPool pool2(pool1.Detach());
  ThreadPoolWrappers::CPool pool3(CreateThreadpool(nullptr));
  ThreadPoolWrappers::CPool pool4;
  pool4 = ThreadPoolWrappers::CPool(CreateThreadpool(nullptr));

  //Test out the CEnviroment class
  ThreadPoolWrappers::CEnvironment environ1;
  environ1.SetPool(pool4);

  //Test out the CCleanupGroup class
  ThreadPoolWrappers::CCleanupGroup group1;
  bSuccess1 = group1.Create(); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess1);
#pragma warning(suppress: 26462)
  const auto g2 = group1.get();
  UNREFERENCED_PARAMETER(g2);
  ThreadPoolWrappers::CCleanupGroup group2(group1.Detach());
  ThreadPoolWrappers::CCleanupGroup group3(CreateThreadpoolCleanupGroup());

  //Test out the CTimer class
  ThreadPoolWrappers::CTimer timer1;
#pragma warning(suppress: 26462)
  const auto g3 = timer1.get();
  UNREFERENCED_PARAMETER(g3);
  ThreadPoolWrappers::CTimer timer2(timer1.Detach(), true);
  ThreadPoolWrappers::CTimer timer3(CreateThreadpoolTimer(TimerCallback, nullptr, nullptr), true);
  ThreadPoolWrappers::CTimer timer4;
  timer4 = ThreadPoolWrappers::CTimer(CreateThreadpoolTimer(TimerCallback, nullptr, &environ1), true);
  ThreadPoolWrappers::CTimer timer5(CreateThreadpoolTimer(TimerCallback, nullptr, nullptr), true);
#pragma warning(suppress: 26477)
  ATLASSERT(!timer5.IsSet());
  //timer4.SetPeriodicRelative(1000, 500, 0);
  SYSTEMTIME st;
  GetSystemTime(&st);
  st.wSecond = 59;
  const BOOL bUnused = timer4.SetOnceOffAbsoluteEx(st, 0);
  UNREFERENCED_PARAMETER(bUnused);
  Sleep(21000);
  timer4.CeaseEx();
  ThreadPoolWrappers::CWait wait1;
#pragma warning(suppress: 26462)
  const auto g4 = wait1.get();
  UNREFERENCED_PARAMETER(g4);
  ThreadPoolWrappers::CWait wait2(wait1.Detach(), true);
  ThreadPoolWrappers::CWait wait3(CreateThreadpoolWait(WaitCallback, nullptr, nullptr), true);
  ThreadPoolWrappers::CWait wait4;
  wait3 = ThreadPoolWrappers::CWait(CreateThreadpoolWait(WaitCallback, nullptr, &environ1), true);
  HANDLE hEvent = CreateEvent(nullptr, FALSE, FALSE, nullptr);
#pragma warning(suppress: 26477)
  ATLASSUME(hEvent != nullptr);
  wait3.Set(hEvent, nullptr);
  SetEvent(hEvent);
  wait3.WaitForCallbacks(FALSE);
  wait3.SetEx(hEvent, nullptr, nullptr);
  SetEvent(hEvent);
  wait3.WaitForCallbacks(FALSE);
  CloseHandle(hEvent);

  //Test out the CIO class
  ATL::CAtlString sTempPath;
  const DWORD dwChars = GetTempPath(_MAX_PATH, sTempPath.GetBuffer(_MAX_PATH));
  sTempPath.ReleaseBuffer();
#pragma warning(suppress: 26477)
  ATLASSERT(dwChars);
  UNREFERENCED_PARAMETER(dwChars);
  ATL::CAtlString sTempFile;
  UINT nChars = GetTempFileName(sTempPath, _T("TPW"), 0, sTempFile.GetBuffer(_MAX_PATH));
  sTempFile.ReleaseBuffer();
#pragma warning(suppress: 26477)
  ATLASSERT(nChars);
  UNREFERENCED_PARAMETER(nChars);
#pragma warning(suppress: 26477)
  HANDLE hFile = CreateFile(sTempFile, GENERIC_WRITE, FILE_SHARE_READ, nullptr, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED, nullptr);
#pragma warning(suppress: 26477)
  ATLASSERT(hFile != INVALID_HANDLE_VALUE);
  ThreadPoolWrappers::CIO io1;
#pragma warning(suppress: 26462)
  const auto g5 = io1.get();
  UNREFERENCED_PARAMETER(g5);
  ThreadPoolWrappers::CIO io2(io1.Detach(), true);
  ThreadPoolWrappers::CIO io3;
  bSuccess1 = io3.Create(hFile, IoCallback, nullptr, &environ1); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSUME(bSuccess1);
  io3.Start();
  std::array<BYTE, 10> byBuffer{ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
  DWORD dwBytesWritten = 0;
  OVERLAPPED overlapped{};
#pragma warning(suppress: 26486)
  BOOL bSuccess = WriteFile(hFile, byBuffer.data(), 10, &dwBytesWritten, &overlapped);
  DWORD dwError = GetLastError();
  bool bCancelIO = bSuccess || (dwError != ERROR_IO_PENDING);
  if (bCancelIO)
    io3.Cancel();
  else
    io3.WaitForCallbacks(FALSE);
  //io3.Cancel();
  CloseHandle(hFile);

  //Test out the CWork class
  ThreadPoolWrappers::CWork work1;
#pragma warning(suppress: 26462)
  const auto g6 = work1.get();
  UNREFERENCED_PARAMETER(g6);
  ThreadPoolWrappers::CWork work2(work1.Detach(), true);
  ThreadPoolWrappers::CWork work3(CreateThreadpoolWork(WorkCallback, nullptr, nullptr), true);
  ThreadPoolWrappers::CWork work4;
  ThreadPoolWrappers::CWork work5;
  work5 = ThreadPoolWrappers::CWork(CreateThreadpoolWork(WorkCallback, nullptr, &environ1), true);
  work5.Submit();

  //Test out the CThreadPool class
  ThreadPoolWrappers::CThreadPool tp1;
  bSuccess = tp1.CreateNew(GetModuleHandle(nullptr), -1, -1, CleanupCallback); //NOLINT(clang-analyzer-deadcode.DeadStores)
  //bSuccess = tp1.Create(GetModuleHandle(nullptr), CleanupCallback); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSERT(bSuccess);
  ThreadPoolWrappers::CWork work6;
  bSuccess1 = tp1.SubmitWork(DoWork1, nullptr, work6); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSERT(bSuccess1);
  //bSuccess1 = tp1.CancelWork(DoWork1, work6); //NOLINT(clang-analyzer-deadcode.DeadStores)
  //ATLASSERT(bSuccess1);
  Sleep(1000);

  GetSystemTime(&st);
  st.wSecond = 59;
  ThreadPoolWrappers::CTimer timer6;
  bSuccess1 = tp1.SubmitOnceOffAbsoluteTimer(DoTimer1, nullptr, st, 0, timer6); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSERT(bSuccess1);
  Sleep(61000);

  ThreadPoolWrappers::CTimer timer7;
  bSuccess1 = tp1.SubmitOnceOffRelativeTimer(DoTimer2, nullptr, 2000, 0, timer7); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSERT(bSuccess1);
  Sleep(3000);

  HANDLE hEvent2 = CreateEvent(nullptr, FALSE, FALSE, nullptr);
#pragma warning(suppress: 26477)
  ATLASSUME(hEvent2 != nullptr);
  GetSystemTime(&st);
  st.wSecond = 59;
  ThreadPoolWrappers::CWait wait5;
  tp1.WaitForKernelObjectAbsolute(DoWait1, nullptr, hEvent2, st, wait5);
  //tp1.CancelWaitForKernelObject(DoWait1, wait5);
  Sleep(2000);
  SetEvent(hEvent2);
  //wait5.WaitForCallbacks(FALSE);
  ThreadPoolWrappers::CWait wait6;
  tp1.WaitForKernelObjectRelative(DoWait2, nullptr, hEvent2, 2000, wait6);
  Sleep(1000);
  SetEvent(hEvent2);
  CloseHandle(hEvent2);

  ThreadPoolWrappers::CTimer timer8;
  bSuccess1 = tp1.SubmitPeriodicRelativeTimer(DoTimer3, nullptr, 1000, 2000, 0, timer8); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSERT(bSuccess1);
  Sleep(5000);
  //bSuccess1 = tp1.CancelTimer(DoTimer3, timer8); //NOLINT(clang-analyzer-deadcode.DeadStores)
  //ATLASSERT(bSuccess1);

  ThreadPoolWrappers::CTimer timer9;
  GetSystemTime(&st);
  st.wSecond = 59;
  bSuccess1 = tp1.SubmitPeriodicAbsoluteTimer(DoTimer4, nullptr, st, 2000, 0, timer9); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSERT(bSuccess1);
  Sleep(61000);
  //bSuccess1 = tp1.CancelTimer(DoTimer4, timer9); //NOLINT(clang-analyzer-deadcode.DeadStores)
  //ATLASSERT(bSuccess1);

  nChars = GetTempFileName(sTempPath, _T("TPW"), 0, sTempFile.GetBuffer(_MAX_PATH));
  sTempFile.ReleaseBuffer();
#pragma warning(suppress: 26477)
  ATLASSERT(nChars);
  UNREFERENCED_PARAMETER(nChars);
#pragma warning(suppress: 26477)
  hFile = CreateFile(sTempFile, GENERIC_WRITE, FILE_SHARE_READ, nullptr, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED, nullptr);
#pragma warning(suppress: 26477)
  ATLASSERT(hFile != INVALID_HANDLE_VALUE);
  ThreadPoolWrappers::CIO io4;
  bSuccess1 = tp1.SubmitIO(DoIo1, nullptr, hFile, io4); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
  ATLASSERT(bSuccess1);
  dwBytesWritten = 0;
  overlapped = {};
  bSuccess = WriteFile(hFile, byBuffer.data(), 10, &dwBytesWritten, &overlapped);
  dwError = GetLastError();
  bCancelIO = bSuccess || (dwError != ERROR_IO_PENDING);
  if (bCancelIO)
    io4.Cancel();
  else
    io4.WaitForCallbacks(FALSE);
  CloseHandle(hFile);

  //Finally lets produce a number of work callbacks at roughly 10x the speed at which they will be consumed by the DoWork2 callback
  //to observe the long term memory behaviour of the thread pool. We will produce 10 work items per time slice (10 - 16 ms). 
  //What you should see is the process memory usage gradually increase over a period of 60 seconds and the CPU peg at close to 100%
  //utilization
  {
    ThreadPoolWrappers::CThreadPool tp2;
    bSuccess = tp2.CreateNew(GetModuleHandle(nullptr), -1, -1, CleanupCallback); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
    ATLASSERT(bSuccess);

    const ULONGLONG nStartTick = GetTickCount64();
    ULONGLONG nLastTick = nStartTick;
    bool bContinue = true;
    while (bContinue)
    {
      const ULONGLONG nCurrentTick = GetTickCount64();
      bContinue = ((nCurrentTick - nStartTick) < 60000);
      if (nCurrentTick != nLastTick)
      {
        for (int i = 0; i < 10; i++)
        {
          ThreadPoolWrappers::CWork work7;
          bSuccess1 = tp2.SubmitWork(DoWork2, nullptr, work7); //NOLINT(clang-analyzer-deadcode.DeadStores)
#pragma warning(suppress: 26477)
          ATLASSERT(bSuccess1);
        }
      }
      nLastTick = nCurrentTick;
    }
  }

  return 0;
}
